package com.github.gkutiel.filter;

import org.apache.commons.fileupload.FileItem;

import com.github.gkutiel.filter.ParamParser.FileItemParamParser;
import com.github.gkutiel.filter.ParamParser.StringParamParser;

public class DefaultParsers {
	public static final ParamParser<Boolean> boolParser = new StringParamParser<Boolean>() {

		@Override
		protected Boolean parseString(final String val) {
			if (val == null || val.isEmpty() || "false".equals(val.toLowerCase())) return false;
			return true;
		}
	};

	public static final ParamParser<FileItem> fileItemParser = new FileItemParamParser<FileItem>() {

		@Override
		protected FileItem parseFileItem(final FileItem val) {
			return val;
		}
	};

	public static final ParamParser<String> stringParser = new StringParamParser<String>() {

		@Override
		protected String parseString(final String val) {
			return val;
		}
	};

}
