package com.github.gkutiel.filter;

import static com.github.gkutiel.filter.Invoker.invoke;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.github.gkutiel.filter.Filter.RedirectException;
import com.github.gkutiel.filter.FilterServer.InjectorBuilder;

class FilterHandler extends HttpServlet {
	private final Class<? extends Filter> filter;
	private final InjectorBuilder injectorBuilder;

	public FilterHandler(final Class<? extends Filter> filter, final InjectorBuilder injectorBuilder) {
		this.filter = filter;
		this.injectorBuilder = injectorBuilder;
	}

	@Override
	protected void doGet(final HttpServletRequest req, final HttpServletResponse res) throws ServletException, IOException {
		try {
			invoke(new FilterChainBuilder(injectorBuilder.build(req, res)).build(filter));
		} catch (final RedirectException e) {}
	}

	@Override
	protected void doPost(final HttpServletRequest req, final HttpServletResponse res) throws ServletException, IOException {
		doGet(req, res);
	}
}