package com.github.gkutiel.filter;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;

import com.github.gkutiel.filter.Val.FileItemVal;
import com.github.gkutiel.filter.Val.NullVal;
import com.github.gkutiel.filter.Val.StringVal;

class MultipartInjector extends Injector {

	final private Map<String, FileItem> fileItems = new HashMap<>();

	MultipartInjector(final Map<Class<?>, ParamParser<?>> parsers, final HttpServletRequest req, final HttpServletResponse res) {
		super(parsers, req, res);
		try {
			for (final FileItem fileItem : new ServletFileUpload(new DiskFileItemFactory()).parseRequest(req))
				fileItems.put(fileItem.getFieldName(), fileItem);
		} catch (final Exception e) {
			throw new RuntimeException(e);
		}
	}

	@Override
	protected Val getVal(final String name) {
		final FileItem fileItem = fileItems.get(name);
		if (fileItem == null) return new NullVal();
		if (fileItem.isFormField()) return new StringVal(fileItem.getString());
		return new FileItemVal(fileItem);
	}
}