package com.github.gkutiel.filter;

import org.apache.commons.fileupload.FileItem;

import com.github.gkutiel.filter.Val.FileItemVisitor;
import com.github.gkutiel.filter.Val.StringVisitor;

public interface ParamParser<T> {
	public static abstract class FileItemParamParser<T> implements ParamParser<T> {
		@Override
		final public T parse(final Val val) {
			return val.accept(new FileItemVisitor<T>() {

				@Override
				public T visit(final FileItem val) {
					return parseFileItem(val);
				}
			});
		}

		protected abstract T parseFileItem(FileItem val);
	}

	public static abstract class StringParamParser<T> implements ParamParser<T> {
		@Override
		final public T parse(final Val val) {
			return val.accept(new StringVisitor<T>() {

				@Override
				public T visit(final String val) {
					return parseString(val);
				}
			});
		}

		protected abstract T parseString(String val);
	}

	T parse(Val val);
}