package com.github.gkutiel.filter;

import static java.lang.ClassLoader.getSystemClassLoader;
import static java.lang.reflect.Proxy.newProxyInstance;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;

import org.eclipse.jetty.websocket.api.RemoteEndpoint;
import org.eclipse.jetty.websocket.api.Session;

import com.google.gson.Gson;

class RemoteProxy {
	static class FunctionCall {
		final String name;
		final Object[] args;

		FunctionCall(final String name, final Object[] args) {
			this.name = name;
			this.args = args;
		}
	}
	static final Gson GSON = new Gson();

	@SuppressWarnings("unchecked")
	static <T> T newRemote(final Session session, final Class<T> remoteInterface) {
		return (T) newProxyInstance(getSystemClassLoader(), new Class<?>[] { remoteInterface }, new InvocationHandler() {
			private final RemoteEndpoint remoteEndpoint = session.getRemote();

			@Override
			@SuppressWarnings("unused")
			public Object invoke(final Object proxy, final Method method, final Object[] args) throws Throwable {
				try {
					if (remoteInterface.equals(method.getDeclaringClass())) {
						if (method.getName().equals("close")) session.close();
						else remoteEndpoint.sendStringByFuture(GSON.toJson(new FunctionCall(method.getName(), args)));
						return null;
					}
					return method.invoke(session, args);
				} catch (final Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					return null;
				}
			}
		});
	}
}
