package com.github.gkutiel.filter;

import static java.lang.annotation.ElementType.TYPE;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.io.IOException;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

public abstract class Resource extends Filter {
	@Inherited
	@Target(TYPE)
	@Retention(RUNTIME)
	public @interface MimeType {
		String value();
	}

	@Override
	final public void apply() {
		try {
			res.setContentType(mime());
			res.getOutputStream().write(bytes());
		} catch (final IOException e) {
			throw new RuntimeException(e);
		}
	}

	public abstract byte[] bytes();

	final public String mime() {
		return getClass().getAnnotation(MimeType.class).value();
	}
}
