package com.github.gkutiel.filter;

import static com.github.gkutiel.filter.Util.load;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.eclipse.jetty.server.Request;
import org.eclipse.jetty.util.resource.Resource;

class ResourceHandler extends org.eclipse.jetty.server.handler.ResourceHandler {

	private static final String FILTER_JS_FILE = "filter.js";
	private static final String FILTER_JS = load(FILTER_JS_FILE);

	ResourceHandler() {
		setResourceBase("web");
		setWelcomeFiles(new String[] { "index.html", "index.xml" });
	}

	@Override
	public void handle(final String target, final Request b, final HttpServletRequest r, final HttpServletResponse re) throws IOException, ServletException {
		if (target.equals("/" + FILTER_JS_FILE)) {
			re.getOutputStream().print(FILTER_JS);
			b.setHandled(true);
			return;
		}

		try (final Resource f = getResource(r);) {
			if (f == null || !f.exists()) return;
			if (f.isDirectory() && getWelcome(f) == null) return;
			super.handle(target, b, r, re);
		}
	}
}
