package com.github.gkutiel.filter;

import org.apache.commons.fileupload.FileItem;

public abstract class Val {
	public abstract static class FileItemVisitor<T> implements ValVisitor<T> {
		@Override
		public T visit(final String val) {
			throw new IllegalStateException("Expecting FileItem, found " + val);
		}
	}

	public abstract static class StringVisitor<T> implements ValVisitor<T> {
		@Override
		public final T visit(final FileItem val) {
			throw new IllegalStateException("Expecting String, found " + val);
		}
	}

	public interface ValVisitor<T> {
		T visit(FileItem val);
		T visit(String val);
	}

	static class FileItemVal extends Val {
		private final FileItem fileItem;

		public FileItemVal(final FileItem fileItem) {
			this.fileItem = fileItem;
		}

		@Override
		public <T> T accept(final ValVisitor<T> valVistor) {
			return valVistor.visit(fileItem);
		}

	}

	static class NullVal extends Val {

		@Override
		public <T> T accept(@SuppressWarnings("unused") final ValVisitor<T> valVistor) {
			return null;
		}

	}

	static class StringVal extends Val {

		private final String str;

		public StringVal(final String str) {
			this.str = str;
		}

		@Override
		public <T> T accept(final ValVisitor<T> valVistor) {
			return valVistor.visit(str);
		}
	}

	public abstract <T> T accept(ValVisitor<T> valVistor);
}